PF-build.sh 62 KB

1234567891011121314151617181920212223242526272829303132333435363738394041424344454647484950515253545556575859606162636465666768697071727374757677787980818283848586878889909192939495969798991001011021031041051061071081091101111121131141151161171181191201211221231241251261271281291301311321331341351361371381391401411421431441451461471481491501511521531541551561571581591601611621631641651661671681691701711721731741751761771781791801811821831841851861871881891901911921931941951961971981992002012022032042052062072082092102112122132142152162172182192202212222232242252262272282292302312322332342352362372382392402412422432442452462472482492502512522532542552562572582592602612622632642652662672682692702712722732742752762772782792802812822832842852862872882892902912922932942952962972982993003013023033043053063073083093103113123133143153163173183193203213223233243253263273283293303313323333343353363373383393403413423433443453463473483493503513523533543553563573583593603613623633643653663673683693703713723733743753763773783793803813823833843853863873883893903913923933943953963973983994004014024034044054064074084094104114124134144154164174184194204214224234244254264274284294304314324334344354364374384394404414424434444454464474484494504514524534544554564574584594604614624634644654664674684694704714724734744754764774784794804814824834844854864874884894904914924934944954964974984995005015025035045055065075085095105115125135145155165175185195205215225235245255265275285295305315325335345355365375385395405415425435445455465475485495505515525535545555565575585595605615625635645655665675685695705715725735745755765775785795805815825835845855865875885895905915925935945955965975985996006016026036046056066076086096106116126136146156166176186196206216226236246256266276286296306316326336346356366376386396406416426436446456466476486496506516526536546556566576586596606616626636646656666676686696706716726736746756766776786796806816826836846856866876886896906916926936946956966976986997007017027037047057067077087097107117127137147157167177187197207217227237247257267277287297307317327337347357367377387397407417427437447457467477487497507517527537547557567577587597607617627637647657667677687697707717727737747757767777787797807817827837847857867877887897907917927937947957967977987998008018028038048058068078088098108118128138148158168178188198208218228238248258268278288298308318328338348358368378388398408418428438448458468478488498508518528538548558568578588598608618628638648658668678688698708718728738748758768778788798808818828838848858868878888898908918928938948958968978988999009019029039049059069079089099109119129139149159169179189199209219229239249259269279289299309319329339349359369379389399409419429439449459469479489499509519529539549559569579589599609619629639649659669679689699709719729739749759769779789799809819829839849859869879889899909919929939949959969979989991000100110021003100410051006100710081009101010111012101310141015101610171018101910201021102210231024102510261027102810291030103110321033103410351036103710381039104010411042104310441045104610471048104910501051105210531054105510561057105810591060106110621063106410651066106710681069107010711072107310741075107610771078107910801081108210831084108510861087108810891090109110921093109410951096109710981099110011011102110311041105110611071108110911101111111211131114111511161117111811191120112111221123112411251126112711281129113011311132113311341135113611371138113911401141114211431144114511461147114811491150115111521153115411551156115711581159116011611162116311641165116611671168116911701171117211731174117511761177117811791180118111821183118411851186118711881189119011911192119311941195119611971198119912001201120212031204120512061207120812091210121112121213121412151216121712181219122012211222122312241225122612271228122912301231123212331234123512361237123812391240124112421243124412451246124712481249125012511252125312541255125612571258
  1. #!/bin/bash
  2. # This bash script is used to compile automatically the Prusa firmware with a dedicated build environment and settings
  3. #
  4. # Supported OS: Windows 10, Linux64 bit
  5. # Beta OS: Linux32 bit
  6. #
  7. # Linux:
  8. #
  9. # Windows:
  10. # To execute this script you gonna need few things on your Windows machine
  11. #
  12. # Linux Subsystem Ubuntu
  13. # 1. Follow these instructions
  14. # 2. Open Ubuntu bash and get latest updates with 'apt-get update'
  15. # 3. Install zip with 'apt-get install zip'
  16. # 4. Install python3 with 'apt-get install python3'
  17. # 5. Add command 'ln -sf /usr/bin/python3.5 /usr/bin/python' to link python3 to python.
  18. # Do not install 'python' as python 2.x has end of life see https://pythonclock.org/
  19. # 6. Add at top of ~/.bashrc following lines by using 'sudo nano ~/.bashrc'
  20. #
  21. # export OS="Linux"
  22. # export JAVA_TOOL_OPTIONS="-Djava.net.preferIPv4Stack=true"
  23. # export GPG_TTY=$(tty)
  24. #
  25. # and confirm them. Restart Ubuntu bash
  26. #
  27. # Or GIT-BASH
  28. # 1. Download and install the correct (64bit or 32bit) Git version https://git-scm.com/download/win
  29. # 2. Also follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058
  30. # 3. Download and install 7z-zip from its official website.
  31. # By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case.
  32. # 4. Run git Bash under Administrator privilege and navigate to the directory /c/Program Files/Git/mingw64/bin,
  33. # you can run the command ln -s /c/Program Files/7-Zip/7z.exe zip.exe
  34. #
  35. # Useful things to edit and compare your custom Firmware
  36. # 1. Download and install current and correct (64bit or 32bit) Notepad++ version https://notepad-plus-plus.org/download
  37. # 2. Another great tool to compare your custom mod and stock firmware is WinMerge http://winmerge.org/downloads/?lang=en
  38. #
  39. # Example for MK3: open git bash and change to your Firmware directory
  40. # <username>@<machine name> MINGW64 /<drive>/path
  41. # bash build.sh 1_75mm_MK3-EINSy10a-E3Dv6full
  42. #
  43. # Example for MK25: open git bash and change to your directory
  44. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware/MK3
  45. # bash build.sh 1_75mm_MK25-RAMBo13a-E3Dv6full
  46. #
  47. # The compiled hex files can be found in the folder above like from the example
  48. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware
  49. # FW351-Build1778-1_75mm_MK25-RAMBo13a-E3Dv6full.hex
  50. #
  51. # Why make Arduino IDE portable?
  52. # To have a distinguished Prusa Firmware build environment I decided to use Arduino IDE in portable mode.
  53. # - Changes made to other Arduino instances do not change anything in this build environment.
  54. # By default Arduino IDE uses "users" and shared library folders which is useful as soon you update the Software.
  55. # But in this case we need a stable and defined build environment, so keep it separated it kind of important.
  56. # Some may argue that this is only used by a script, BUT as soon someone accidentally or on purpose starts Arduino IDE
  57. # it will use the default Arduino IDE folders and so can corrupt the build environment.
  58. #
  59. # Version: 2.0.0-Build_57
  60. # Change log:
  61. # 12 Jan 2019, 3d-gussner, Fixed "compiler.c.elf.flags=-w -Os -Wl,-u,vfprintf -lprintf_flt -lm -Wl,--gc-sections" in 'platform.txt'
  62. # 16 Jan 2019, 3d-gussner, Build_2, Added development check to modify 'Configuration.h' to prevent unwanted LCD messages that Firmware is unknown
  63. # 17 Jan 2019, 3d-gussner, Build_3, Check for OS Windows or Linux and use the right build environment
  64. # 10 Feb 2019, ropaha, Pull Request, Select variant from list while using build.sh
  65. # 10 Feb 2019, ropaha, change FW_DEV_VERSION automatically depending on FW_VERSION RC/BETA/ALPHA
  66. # 10 Feb 2019, 3d-gussner, 1st tests with English only
  67. # 10 Feb 2019, ropaha, added compiling of all variants and English only
  68. # 10 Feb 2019, 3d-gussner, Set OUTPUT_FOLDER for hex files
  69. # 11 Feb 2019, 3d-gussner/ropaha, Minor changes and fixes
  70. # 11 Feb 2019, 3d-gussner, Ready for RC
  71. # 12 Feb 2019, 3d-gussner, Check if wget and zip are installed. Thanks to Bernd to point it out
  72. # 12 Feb 2019, 3d-gussner, Changed OS check to OSTYPE as it is not supported on Ubuntu
  73. # Also added different BUILD_ENV folders depending on OS used so Windows
  74. # Users can use git-bash AND Windows Linux Subsystems at the same time
  75. # Cleanup compiler flags is only depends on OS version.
  76. # 12 Feb 2019, 3d-gussner, Added additional OSTYPE check
  77. # 15 feb 2019, 3d-gussner, Added zip files for miniRAMbo multi language hex files
  78. # 15 Feb 2019, 3d-gussner, Added more checks if
  79. # Compiled Hex-files
  80. # Configuration_prusa.h
  81. # language build files
  82. # multi language firmware files exist and clean them up
  83. # 15 Feb 2019, 3d-gussner, Fixed selection GOLD/UNKNOWN DEV_STATUS for ALL variants builds, so you have to choose only once
  84. # 15 Feb 2019, 3d-gussner, Added some colored output
  85. # 15 Feb 2019, 3d-gussner, troubleshooting and minor fixes
  86. # 16 Feb 2019, 3d-gussner, Script can be run using arguments
  87. # $1 = variant, example "1_75mm_MK3-EINSy10a-E3Dv6full.h" at this moment it is not possible to use ALL
  88. # $2 = multi language OR English only [ALL/EN_ONLY]
  89. # $3 = development status [GOLD/RC/BETA/ALPHA/DEVEL/DEBUG]
  90. # If one argument is wrong a list of valid one will be shown
  91. # 13 Mar 2019, 3d-gussner, MKbel updated the Linux build environment to version 1.0.2 with an Fix maximum firmware flash size.
  92. # So did I
  93. # 11 Jul 2019, deliopoulos,Updated to v1.0.6 as Prusa needs a new board definition for Firmware 3.8.x86_64
  94. # - Split the Download of Windows Arduino IDE 1.8.5 and Prusa specific part
  95. # --> less download volume needed and saves some time
  96. #
  97. # 13 Jul 2019, deliopoulos,Splitting of Arduino IDE and Prusa parts also for Linux64
  98. # 13 Jul 2019, 3d-gussner, Added Linux 32-bit version (untested yet)
  99. # MacOS could be added in future if needs
  100. # 14 Jul 2019, 3d-gussner, Update preferences and make it really portable
  101. # 15 Jul 2019, 3d-gussner, New PF-build-env GitHub branch
  102. # 16 Jul 2019, 3d-gussner, New Arduino_boards GitHub fork
  103. # 17 Jul 2019, 3d-gussner, Final tests under Windows 10 and Linux Subsystem for Windows
  104. # 18 Jul 2019, 3d-gussner, Added python check
  105. # 18 Jul 2019, deliopoulos, No need more for changing 'platform.txt' file as it comes with the Arduino Boards.
  106. # 18 Jul 2019, deliopoulos, Modified 'PF_BUILD_FILE_URL' to use 'BUILD_ENV' variable
  107. # 22 Jul 2019, 3d-gussner, Modified checks to check folder and/or installation output exists.
  108. # 22 Jul 2019, 3d-gussner, Added check if Arduino IDE 1.8.5 boards have been updated
  109. # 22 Jul 2019, 3d-gussner, Changed exit numbers 1-13 for prepare build env 21-28 for prepare compiling 31-36 compiling
  110. # 22 Jul 2019, 3d-gussner, Changed BOARD_URL to DRracers repository after he pulled my PR https://github.com/DRracer/Arduino_Boards/pull/1
  111. # 23 Jul 2019, 3d-gussner, Changed Build-env path to "PF-build-dl" as requested in PR https://github.com/prusa3d/Prusa-Firmware/pull/2028
  112. # Changed Hex-files folder to PF-build-hex as requested in PR
  113. # 23 Jul 2019, 3d-gussner, Added Finding OS version routine so supporting new OS should get easier
  114. # 26 Jul 2019, 3d-gussner, Change JSON repository to prusa3d after PR https://github.com/prusa3d/Arduino_Boards/pull/1 was merged
  115. # 23 Sep 2019, 3d-gussner, Prepare PF-build.sh for coming Prusa3d/Arduino_Boards version 1.0.2 Pull Request
  116. # 17 Oct 2019, 3d-gussner, Changed folder and check file names to have separated build environments depending on Arduino IDE version and
  117. # board-versions.
  118. # 15 Dec 2019, 3d-gussner, Prepare for switch to Prusa3d/PF-build-env repository
  119. # 15 Dec 2019, 3d-gussner, Fix Arduino user preferences for the chosen board.
  120. # 17 Dec 2019, 3d-gussner, Fix "timer0_fract = 0" warning by using Arduino_boards v1.0.3
  121. # 28 Apr 2020, 3d-gussner, Added RC3 detection
  122. # 03 May 2020, deliopoulos, Accept all RCx as RC versions
  123. # 05 May 2020, 3d-gussner, Make a copy of `not_tran.txt`and `not_used.txt` as `not_tran_$VARIANT.txt`and `not_used_$VARIANT.txt`
  124. # After compiling All multi-language variants it makes it easier to find missing or unused translations.
  125. # 12 May 2020, DRracer , Cleanup double MK2/s MK25/s `not_tran` and `not_used` files
  126. # 13 May 2020, leptun , If cleanup files do not exist don't try to.
  127. # 01 Oct 2020, 3d-gussner, Bug fix if using argument EN_ONLY. Thank to @leptun for pointing out.
  128. # Change Build number to script commits 'git rev-list --count HEAD PF-build.sh'
  129. # 02 Oct 2020, 3d-gussner, Add UNKNOWN as argument option
  130. # 05 Oct 2020, 3d-gussner, Disable pause and warnings using command line with all needed arguments
  131. # Install needed apps under linux if needed.
  132. # Clean PF-Firmware build when changing git branch
  133. # 02 Nov 2020, 3d-gussner, Check for "gawk" on Linux
  134. # Add argument to change build number automatically to current commit or define own number
  135. # Update exit numbers 1-13 for prepare build env 21-29 for prepare compiling 30-36 compiling
  136. # 08 Jan 2021, 3d-gussner, Comment out 'sudo' auto installation
  137. # Add '-?' '-h' help option
  138. # 27 Jan 2021, 3d-gussner, Add `-c`, `-p` and `-n` options
  139. # 12 Feb 2021, 3d-gussner, Add MK404-build.sh
  140. # 13 Feb 2021, 3d-gussner, Indentations
  141. # 13 Feb 2021, 3d-gussner, MK404 improvements like "flash" MK3, MK3S languages files to MK404 xflash.
  142. # 27 Feb 2021, 3d-gussner, Add './lang-community.sh' and update exits
  143. # 03 May 2021, 3d-gussner, Update exit numbers
  144. # 01-14 prepare build env
  145. # 21-32 prepare compiling
  146. # 41-47 compiling
  147. # 51-54 cleanup
  148. # 61-62 MK404
  149. # 03 May 2021, 3d-gussner, Update documentation and change version to v1.2.0
  150. # 03 May 2021, 3d-gussner, Add SIM atmega404
  151. # 17 Jun 2021, 3d-gussner, Update PF-build.sh to work after DRracer Remove FW version parsing PR
  152. # 17 Jun 2021, 3d-gussner, Save ELF files for FW3.10.1 debugging PRs
  153. # 17 Jun 2021, 3d-gussner, Add verbose_IDE to output more information during build
  154. # 17 Jun 2021, 3d-gussner, Change version to v2.0.0
  155. # 18 Jun 2021, 3d-gussner, Use atmega404 if extanded RAM or FLASH size are chosen
  156. # 18 Jun 2021, 3d-gussner, Remove MK404 copy of lang file as it has been fixed in MK404
  157. # 21 Jun 2021, 3d-gussner, Change atmega404 board flash argument to y
  158. # Use newer version of MK404-build.sh instead start the program
  159. #### Start check if OSTYPE is supported
  160. OS_FOUND=$( command -v uname)
  161. case $( "${OS_FOUND}" | tr '[:upper:]' '[:lower:]') in
  162. linux*)
  163. TARGET_OS="linux"
  164. ;;
  165. msys*|cygwin*|mingw*)
  166. # or possible 'bash on windows'
  167. TARGET_OS='windows'
  168. ;;
  169. nt|win*)
  170. TARGET_OS='windows'
  171. ;;
  172. *)
  173. TARGET_OS='unknown'
  174. ;;
  175. esac
  176. # Windows
  177. if [ $TARGET_OS == "windows" ]; then
  178. if [ $(uname -m) == "x86_64" ]; then
  179. echo "$(tput setaf 2)Windows 64-bit found$(tput sgr0)"
  180. Processor="64"
  181. elif [ $(uname -m) == "i386" ]; then
  182. echo "$(tput setaf 2)Windows 32-bit found$(tput sgr0)"
  183. Processor="32"
  184. else
  185. echo "$(tput setaf 1)Unsupported OS: Windows $(uname -m)"
  186. echo "Please refer to the notes of build.sh$(tput sgr0)"
  187. exit 1
  188. fi
  189. # Linux
  190. elif [ $TARGET_OS == "linux" ]; then
  191. if [ $(uname -m) == "x86_64" ]; then
  192. echo "$(tput setaf 2)Linux 64-bit found$(tput sgr0)"
  193. Processor="64"
  194. elif [[ $(uname -m) == "i386" || $(uname -m) == "i686" ]]; then
  195. echo "$(tput setaf 2)Linux 32-bit found$(tput sgr0)"
  196. Processor="32"
  197. else
  198. echo "$(tput setaf 1)Unsupported OS: Linux $(uname -m)"
  199. echo "Please refer to the notes of build.sh$(tput sgr0)"
  200. exit 1
  201. fi
  202. else
  203. echo "$(tput setaf 1)This script doesn't support your Operating system!"
  204. echo "Please use Linux 64-bit or Windows 10 64-bit with Linux subsystem / git-bash"
  205. echo "Read the notes of build.sh$(tput sgr0)"
  206. exit 1
  207. fi
  208. sleep 2
  209. #### End check if OSTYPE is supported
  210. #### Prepare bash environment and check if wget, zip and other needed things are available
  211. # Check wget
  212. if ! type wget > /dev/null; then
  213. echo "$(tput setaf 1)Missing 'wget' which is important to run this script"
  214. echo "Please follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058 to install wget$(tput sgr0)"
  215. exit 2
  216. fi
  217. # Check for zip
  218. if ! type zip > /dev/null; then
  219. if [ $TARGET_OS == "windows" ]; then
  220. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  221. echo "Download and install 7z-zip from its official website https://www.7-zip.org/"
  222. echo "By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case."
  223. echo "Run git Bash under Administrator privilege and"
  224. echo "navigate to the directory /c/Program Files/Git/mingw64/bin,"
  225. echo "you can run the command $(tput setaf 2)ln -s /c/Program Files/7-Zip/7z.exe zip.exe$(tput sgr0)"
  226. exit 3
  227. elif [ $TARGET_OS == "linux" ]; then
  228. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  229. echo "install it with the command $(tput setaf 2)'sudo apt-get install zip'$(tput sgr0)"
  230. #sudo apt-get update && apt-get install zip
  231. exit 3
  232. fi
  233. fi
  234. # Check python ... needed during language build
  235. if ! type python > /dev/null; then
  236. if [ $TARGET_OS == "windows" ]; then
  237. echo "$(tput setaf 1)Missing 'python3' which is important to run this script"
  238. exit 4
  239. elif [ $TARGET_OS == "linux" ]; then
  240. echo "$(tput setaf 1)Missing 'python' which is important to run this script"
  241. echo "As Python 2.x will not be maintained from 2020 please,"
  242. echo "install it with the command $(tput setaf 2)'sudo apt-get install python3'."
  243. echo "Check which version of Python3 has been installed using 'ls /usr/bin/python3*'"
  244. echo "Use 'sudo ln -sf /usr/bin/python3.x /usr/bin/python' (where 'x' is your version number) to make it default.$(tput sgr0)"
  245. #sudo apt-get update && apt-get install python3 && ln -sf /usr/bin/python3 /usr/bin/python
  246. exit 4
  247. fi
  248. fi
  249. # Check gawk ... needed during language build
  250. if ! type gawk > /dev/null; then
  251. if [ $TARGET_OS == "linux" ]; then
  252. echo "$(tput setaf 1)Missing 'gawk' which is important to run this script"
  253. echo "install it with the command $(tput setaf 2)'sudo apt-get install gawk'."
  254. #sudo apt-get update && apt-get install gawk
  255. exit 5
  256. fi
  257. fi
  258. #### End prepare bash / Linux environment
  259. # Check for options/flags
  260. while getopts b:c:d:g:h:i:j:l:m:n:o:p:v:x:y:?h flag
  261. do
  262. case "${flag}" in
  263. b) build_flag=${OPTARG};;
  264. c) clean_flag=${OPTARG};;
  265. d) devel_flag=${OPTARG};;
  266. g) graphics_flag=${OPTARG};;
  267. h) help_flag=1;;
  268. i) IDE_flag=${OPTARG};;
  269. j) verbose_IDE_flag=${OPTARG};;
  270. l) language_flag=${OPTARG};;
  271. m) mk404_flag=${OPTARG};;
  272. n) new_build_flag=${OPTARG};;
  273. o) output_flag=${OPTARG};;
  274. p) prusa_flag=${OPTARG};;
  275. v) variant_flag=${OPTARG};;
  276. x) board_mem_flag=${OPTARG};;
  277. y) board_flash_flag=${OPTARG};;
  278. ?) help_flag=1;;
  279. esac
  280. done
  281. #
  282. # '?' 'h' argument usage and help
  283. if [ "$help_flag" == "1" ] ; then
  284. echo "***************************************"
  285. echo "* PF-build.sh Version: 2.0.0-Build_57 *"
  286. echo "***************************************"
  287. echo "Arguments:"
  288. echo "$(tput setaf 2)-b$(tput sgr0) Build/commit number '$(tput setaf 2)Auto$(tput sgr0)' needs git or a number"
  289. echo "$(tput setaf 2)-c$(tput sgr0) Do not clean up lang build'$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  290. echo "$(tput setaf 2)-d$(tput sgr0) Devel build '$(tput setaf 2)GOLD$(tput sgr0)', '$(tput setaf 2)RC$(tput sgr0)', '$(tput setaf 2)BETA$(tput sgr0)', '$(tput setaf 2)ALPHA$(tput sgr0)', '$(tput setaf 2)DEBUG$(tput sgr0)', '$(tput setaf 2)DEVEL$(tput sgr0)' and '$(tput setaf 2)UNKNOWN$(tput sgr0)'"
  291. echo "$(tput setaf 2)-g$(tput sgr0) Start MK404 graphics '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' lite '$(tput setaf 2)2$(tput sgr0)' fancy '$(tput setaf 2)3$(tput sgr0)' lite with Quad_HR '$(tput setaf 2)2$(tput sgr0)' fancy with Quad_HR"
  292. echo "$(tput setaf 2)-h$(tput sgr0) Help"
  293. echo "$(tput setaf 2)-i$(tput sgr0) Arduino IDE version '$(tput setaf 2)1.8.5$(tput sgr0)', '$(tput setaf 2)1.8.13$(tput sgr0)'"
  294. echo "$(tput setaf 2)-j$(tput sgr0) Arduino IDE verbose output '$(tput setaf 2)0$(tput sgr0)', '$(tput setaf 2)1$(tput sgr0) active'"
  295. echo "$(tput setaf 2)-l$(tput sgr0) Languages '$(tput setaf 2)ALL$(tput sgr0)' for multi language or '$(tput setaf 2)EN_ONLY$(tput sgr0)' for English only"
  296. echo "$(tput setaf 2)-m$(tput sgr0) Start MK404 sim '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes '$(tput setaf 2)2$(tput sgr0)' with MMU2"
  297. echo "$(tput setaf 2)-n$(tput sgr0) New fresh build '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  298. echo "$(tput setaf 2)-o$(tput sgr0) Output '$(tput setaf 2)1$(tput sgr0)' force or '$(tput setaf 2)0$(tput sgr0)' block output and delays"
  299. echo "$(tput setaf 2)-p$(tput sgr0) Keep Configuration_prusa.h '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  300. echo "$(tput setaf 2)-v$(tput sgr0) Variant '$(tput setaf 2)All$(tput sgr0)' or variant file name"
  301. echo "$(tput setaf 2)-x$(tput sgr0) Board memory size '$(tput setaf 2)8$(tput sgr0)' or '$(tput setaf 2)64$(tput sgr0)' Kb."
  302. echo "$(tput setaf 2)-y$(tput sgr0) Board flash size '$(tput setaf 2)256$(tput sgr0)','$(tput setaf 2)384$(tput sgr0)','$(tput setaf 2)512$(tput sgr0)','$(tput setaf 2)1024$(tput sgr0)''$(tput setaf 2)32M$(tput sgr0)'"
  303. echo "$(tput setaf 2)-?$(tput sgr0) Help"
  304. echo
  305. echo "Brief USAGE:"
  306. echo " $(tput setaf 2)./PF-build.sh$(tput sgr0) [-b] [-c] [-d] [-g] [-i] [-j] [-l] [-m] [-n] [-o] [-p ] -[v] [-x] [-y] [-h] [-?]"
  307. echo
  308. echo "Example:"
  309. echo " $(tput setaf 2)./PF-build.sh -v All -l ALL -d GOLD$(tput sgr0)"
  310. echo " Will build all variants as multi language and final GOLD version"
  311. echo
  312. echo " $(tput setaf 2) ./PF-build.sh -v 1_75mm_MK3S-EINSy10a-E3Dv6full.h -b Auto -l ALL -d GOLD -o 1 -c 1 -p 1 -n 1$(tput sgr0)"
  313. echo " Will build MK3S multi language final GOLD firmware "
  314. echo " with current commit count number and output extra information,"
  315. echo " not delete lang build temporary files, keep Configuration_prusa.h and build with new fresh build folder."
  316. echo
  317. exit 6
  318. fi
  319. #Check if verbose_IDE is selected with argument '-j'
  320. if [ ! -z "$verbose_IDE_flag" ]; then
  321. if [ $verbose_IDE_flag == "1" ]; then
  322. verbose_IDE="1"
  323. elif [ $verbose_IDE_flag == "0" ]; then
  324. verbose_IDE="0"
  325. else
  326. echo "Only '0' and '1' are valid verbose_IDE values."
  327. exit
  328. fi
  329. else
  330. verbose_IDE="0"
  331. fi
  332. #Check if Build is selected with argument '-f'
  333. if [ ! -z "$board_flash_flag" ] ; then
  334. if [ "$board_flash_flag" == "256" ] ; then
  335. BOARD_FLASH="0x3FFFF"
  336. BOARD_maximum_size="253952"
  337. echo "Board flash size : $board_flash_flag Kb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex)"
  338. elif [ "$board_flash_flag" == "384" ] ; then
  339. BOARD_FLASH="0x5FFFF"
  340. BOARD_maximum_size="385024"
  341. echo "Board flash size : $board_flash_flag Kb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex)"
  342. OUTPUT_FILENAME_SUFFIX="${OUTPUT_FILENAME_SUFFIX}_FLASH-$board_flash_flag"
  343. elif [ "$board_flash_flag" == "512" ] ; then
  344. BOARD_FLASH="0x7FFFF"
  345. BOARD_maximum_size="516096"
  346. echo "Board flash size : $board_flash_flag Kb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex)"
  347. OUTPUT_FILENAME_SUFFIX="${OUTPUT_FILENAME_SUFFIX}_FLASH-$board_flash_flag"
  348. elif [ "$board_flash_flag" == "1024" ] ; then
  349. BOARD_FLASH="0xFFFFF"
  350. BOARD_maximum_size="1040384"
  351. echo "Board flash size : $board_flash_flag Kb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex)"
  352. OUTPUT_FILENAME_SUFFIX="${OUTPUT_FILENAME_SUFFIX}_FLASH-$board_flash_flag"
  353. elif [[ "$board_flash_flag" == "32M" || "$board_flash_flag" == "32768" ]] ; then
  354. BOARD_FLASH="0x1FFFFFF"
  355. BOARD_maximum_size="33546240"
  356. echo "Board flash size : 32 Mb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex)"
  357. OUTPUT_FILENAME_SUFFIX="${OUTPUT_FILENAME_SUFFIX}_FLASH-$board_flash_flag"
  358. else
  359. echo "Unsupported board flash size chosen. Only '256', '384', '512', '1024' and '32M' are allowed."
  360. exit 7
  361. fi
  362. fi
  363. #Check if Build is selected with argument '-x'
  364. if [ ! -z "$board_mem_flag" ] ; then
  365. if [ "$board_mem_flag" == "8" ] ; then
  366. BOARD_MEM="0x21FF"
  367. echo "Board mem size : $board_mem_flag Kb, $BOARD_MEM (hex)"
  368. elif [ "$board_mem_flag" == "64" ] ; then
  369. BOARD_MEM="0xFFFF"
  370. echo "Board mem size : $board_mem_flag Kb, $BOARD_MEM (hex)"
  371. OUTPUT_FILENAME_SUFFIX="${OUTPUT_FILENAME_SUFFIX}_RAM-$board_mem_flag"
  372. else
  373. echo "Unsupported board mem size chosen. Only '8', '64' are allowed."
  374. exit 8
  375. fi
  376. fi
  377. #Check if Arduino IDE version is correct
  378. if [ ! -z "$IDE_flag" ]; then
  379. if [[ "$IDE_flag" == "1.8.5" || "$IDE_flag" == "1.8.13" ]]; then
  380. ARDUINO_ENV="${IDE_flag}"
  381. else
  382. ARDUINO_ENV="1.8.5"
  383. fi
  384. else
  385. ARDUINO_ENV="1.8.5"
  386. fi
  387. #### Set build environment
  388. BUILD_ENV="1.0.6"
  389. BOARD="prusa_einsy_rambo"
  390. BOARD_PACKAGE_NAME="PrusaResearch"
  391. if [ "$ARDUINO_ENV" == "1.8.13" ]; then
  392. BOARD_VERSION="1.0.4"
  393. else
  394. BOARD_VERSION="1.0.3"
  395. fi
  396. #BOARD_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/master/IDE_Board_Manager/package_prusa3d_index.json"
  397. BOARD_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/package_prusa3d_index.json"
  398. BOARD_FILENAME="prusa3dboards"
  399. #BOARD_FILE_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/master/IDE_Board_Manager/prusa3dboards-$BOARD_VERSION.tar.bz2"
  400. BOARD_FILE_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/prusa3dboards-$BOARD_VERSION.tar.bz2"
  401. #PF_BUILD_FILE_URL="https://github.com/3d-gussner/PF-build-env-1/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  402. if [[ "$BOARD_VERSION" == "1.0.3" || "$BOARD_VERSION" == "1.0.2" || "$BOARD_VERSION" == "1.0.1" ]]; then
  403. PF_BUILD_FILE_URL="https://github.com/prusa3d/PF-build-env/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  404. fi
  405. LIB="PrusaLibrary"
  406. SCRIPT_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  407. # List few useful data
  408. echo
  409. echo "Script path :" $SCRIPT_PATH
  410. echo "OS :" $OS
  411. echo "OS type :" $TARGET_OS
  412. echo ""
  413. echo "Arduino IDE :" $ARDUINO_ENV
  414. echo "Build env :" $BUILD_ENV
  415. echo "Board :" $BOARD
  416. if [ ! -z "$BOARD_FLASH" ] ; then
  417. echo "Board flash :" $BOARD_FLASH
  418. fi
  419. if [ ! -z "$BOARD_MEM" ] ; then
  420. echo "Board mem :" $BOARD_MEM
  421. fi
  422. echo "Package name:" $BOARD_PACKAGE_NAME
  423. echo "Board v. :" $BOARD_VERSION
  424. echo "Specific Lib:" $LIB
  425. echo ""
  426. #### Start prepare building environment
  427. #Check if build exists and creates it if not
  428. if [ ! -d "../PF-build-dl" ]; then
  429. mkdir ../PF-build-dl || exit 9
  430. fi
  431. cd ../PF-build-dl || exit 10
  432. BUILD_ENV_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  433. # Check if PF-build-env-<version> exists and downloads + creates it if not
  434. # The build environment is based on the supported Arduino IDE portable version with some changes
  435. if [ ! -d "../PF-build-env-$BUILD_ENV" ]; then
  436. echo "$(tput setaf 6)PF-build-env-$BUILD_ENV is missing ... creating it now for you$(tput sgr 0)"
  437. mkdir ../PF-build-env-$BUILD_ENV
  438. sleep 5
  439. fi
  440. # Download and extract supported Arduino IDE depending on OS
  441. # Windows
  442. if [ $TARGET_OS == "windows" ]; then
  443. if [ ! -f "arduino-$ARDUINO_ENV-windows.zip" ]; then
  444. echo "$(tput setaf 6)Downloading Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  445. sleep 2
  446. wget https://downloads.arduino.cc/arduino-$ARDUINO_ENV-windows.zip || exit 8
  447. echo "$(tput sgr 0)"
  448. fi
  449. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  450. echo "$(tput setaf 6)Unzipping Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  451. sleep 2
  452. unzip arduino-$ARDUINO_ENV-windows.zip -d ../PF-build-env-$BUILD_ENV || exit 9
  453. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  454. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  455. echo "$(tput sgr0)"
  456. fi
  457. fi
  458. # Linux
  459. if [ $TARGET_OS == "linux" ]; then
  460. # 32 or 64 bit version
  461. if [ ! -f "arduino-$ARDUINO_ENV-linux$Processor.tar.xz" ]; then
  462. echo "$(tput setaf 6)Downloading Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  463. sleep 2
  464. wget --no-check-certificate https://downloads.arduino.cc/arduino-$ARDUINO_ENV-linux$Processor.tar.xz || exit 8
  465. echo "$(tput sgr 0)"
  466. fi
  467. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  468. echo "$(tput setaf 6)Unzipping Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  469. sleep 2
  470. tar -xvf arduino-$ARDUINO_ENV-linux$Processor.tar.xz -C ../PF-build-env-$BUILD_ENV/ || exit 9
  471. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  472. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  473. echo "$(tput sgr0)"
  474. fi
  475. fi
  476. # Make Arduino IDE portable
  477. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/ ]; then
  478. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/
  479. fi
  480. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/ ]; then
  481. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable
  482. fi
  483. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output/ ]; then
  484. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output
  485. fi
  486. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/ ]; then
  487. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages
  488. fi
  489. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/ ]; then
  490. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook
  491. fi
  492. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries/ ]; then
  493. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries
  494. fi
  495. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging/ ]; then
  496. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging
  497. fi
  498. # Change Arduino IDE preferences
  499. if [ ! -e ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt ]; then
  500. echo "$(tput setaf 6)Setting $ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor Arduino IDE preferences for portable GUI usage...$(tput setaf 2)"
  501. sleep 2
  502. echo "update.check"
  503. sed -i 's/update.check = true/update.check = false/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  504. echo "board"
  505. sed -i "s/board = uno/board = $BOARD/g" ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  506. echo "editor.linenumbers"
  507. sed -i 's/editor.linenumbers = false/editor.linenumbers = true/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  508. echo "boardsmanager.additional.urls"
  509. echo "boardsmanager.additional.urls=$BOARD_URL" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  510. echo "build.verbose=true" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  511. echo "compiler.cache_core=false" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  512. echo "compiler.warning_level=all" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  513. echo "# Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  514. echo "$(tput sgr0)"
  515. fi
  516. # Download and extract Prusa Firmware related parts
  517. # Download and extract PrusaResearchRambo board
  518. if [ ! -f "$BOARD_FILENAME-$BOARD_VERSION.tar.bz2" ]; then
  519. echo "$(tput setaf 6)Downloading Prusa Research AVR MK3 RAMBo EINSy build environment...$(tput setaf 2)"
  520. sleep 2
  521. wget $BOARD_FILE_URL || exit 10
  522. fi
  523. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION" || ! -e "../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  524. echo "$(tput setaf 6)Unzipping $BOARD_PACKAGE_NAME Arduino IDE portable...$(tput setaf 2)"
  525. sleep 2
  526. tar -xvf $BOARD_FILENAME-$BOARD_VERSION.tar.bz2 -C ../PF-build-env-$BUILD_ENV/ || exit 11
  527. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  528. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  529. fi
  530. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  531. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  532. fi
  533. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware ]; then
  534. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware
  535. fi
  536. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr ]; then
  537. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr
  538. fi
  539. mv ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$BOARD_VERSION ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION
  540. echo "# $BOARD_FILENAME-$BOARD_VERSION" >> ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  541. echo "$(tput sgr 0)"
  542. fi
  543. # Download and extract Prusa Firmware specific library files
  544. if [[ "$BOARD_VERSION" == "1.0.3" || "$BOARD_VERSION" == "1.0.2" || "$BOARD_VERSION" == "1.0.1" ]]; then
  545. if [ ! -f "PF-build-env-WinLin-$BUILD_ENV.zip" ]; then
  546. echo "$(tput setaf 6)Downloading Prusa Firmware build environment...$(tput setaf 2)"
  547. sleep 2
  548. wget $PF_BUILD_FILE_URL || exit 12
  549. echo "$(tput sgr 0)"
  550. fi
  551. if [ ! -e "../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]; then
  552. echo "$(tput setaf 6)Unzipping Prusa Firmware build environment...$(tput setaf 2)"
  553. sleep 2
  554. unzip -o PF-build-env-WinLin-$BUILD_ENV.zip -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 13
  555. echo "# PF-build-env-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  556. echo "$(tput sgr0)"
  557. fi
  558. fi
  559. # Check if User updated Arduino IDE 1.8.5 boardsmanager and tools
  560. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools" ]; then
  561. echo "$(tput setaf 6)Arduino IDE boards / tools have been manually updated...$"
  562. echo "Please don't update the 'Arduino AVR boards' as this will prevent running this script (tput setaf 2)"
  563. sleep 2
  564. fi
  565. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2" ]; then
  566. echo "$(tput setaf 6)PrusaReasearch compatible tools have been manually updated...$(tput setaf 2)"
  567. sleep 2
  568. echo "$(tput setaf 6)Copying Prusa Firmware build environment to manually updated boards / tools...$(tput setaf 2)"
  569. sleep 2
  570. cp -f ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/hardware/tools/avr/avr/lib/ldscripts/avr6.xn ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2/avr/lib/ldscripts/avr6.xn
  571. echo "# PF-build-env-portable-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-portable-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  572. echo "$(tput sgr0)"
  573. fi
  574. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/5.4.0-atmel3.6.1-arduino2" ]; then
  575. echo "$(tput setaf 1)Arduino IDE tools have been updated manually to a non supported version!!!"
  576. echo "Delete ../PF-build-env-$BUILD_ENV and start the script again"
  577. echo "Script will not continue until this have been fixed $(tput setaf 2)"
  578. sleep 2
  579. echo "$(tput sgr0)"
  580. exit 14
  581. fi
  582. #### End prepare building
  583. #### Start
  584. cd $SCRIPT_PATH
  585. # Check if git is available
  586. if type git > /dev/null; then
  587. git_available="1"
  588. fi
  589. #
  590. # '-v' argument defines which variant of the Prusa Firmware will be compiled
  591. if [ -z "$variant_flag" ] ; then
  592. # Select which variant of the Prusa Firmware will be compiled, like
  593. PS3="Select a variant: "
  594. while IFS= read -r -d $'\0' f; do
  595. options[i++]="$f"
  596. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  597. select opt in "${options[@]}" "All" "Quit"; do
  598. case $opt in
  599. *.h)
  600. VARIANT=$(basename "$opt" ".h")
  601. VARIANTS[i++]="$opt"
  602. break
  603. ;;
  604. "All")
  605. VARIANT="All"
  606. VARIANTS=${options[*]}
  607. break
  608. ;;
  609. "Quit")
  610. echo "You chose to stop"
  611. exit 22
  612. ;;
  613. *)
  614. echo "$(tput setaf 1)This is not a valid variant$(tput sgr0)"
  615. ;;
  616. esac
  617. done
  618. else
  619. if [ -f "$SCRIPT_PATH/Firmware/variants/$variant_flag" ] ; then
  620. VARIANTS=$variant_flag
  621. elif [ "$variant_flag" == "All" ] ; then
  622. while IFS= read -r -d $'\0' f; do
  623. options[i++]="$f"
  624. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  625. VARIANT="All"
  626. VARIANTS=${options[*]}
  627. else
  628. echo "$(tput setaf 1)Argument $variant_flag could not be found in Firmware/variants please choose a valid one.$(tput sgr0)"
  629. echo "Only $(tput setaf 2)'All'$(tput sgr0) and file names below are allowed as variant '-v' argument.$(tput setaf 2)"
  630. ls -1 $SCRIPT_PATH/Firmware/variants/*.h | xargs -n1 basename
  631. echo "$(tput sgr0)"
  632. exit 23
  633. fi
  634. fi
  635. #'-l' argument defines if it is an English only version. Known values EN_ONLY / ALL
  636. #Check default language mode
  637. MULTI_LANGUAGE_CHECK=$(grep --max-count=1 "^#define LANG_MODE *" $SCRIPT_PATH/Firmware/config.h|sed -e's/ */ /g'|cut -d ' ' -f3)
  638. if [ -z "$language_flag" ] ; then
  639. PS3="Select a language: "
  640. echo
  641. echo "Which lang-build do you want?"
  642. select yn in "Multi languages" "English only"; do
  643. case $yn in
  644. "Multi languages")
  645. LANGUAGES="ALL"
  646. break
  647. ;;
  648. "English only")
  649. LANGUAGES="EN_ONLY"
  650. break
  651. ;;
  652. *)
  653. echo "$(tput setaf 1)This is not a valid language$(tput sgr0)"
  654. ;;
  655. esac
  656. done
  657. else
  658. if [[ "$language_flag" == "ALL" || "$language_flag" == "EN_ONLY" ]] ; then
  659. LANGUAGES=$language_flag
  660. else
  661. echo "$(tput setaf 1)Language argument is wrong!$(tput sgr0)"
  662. echo "Only $(tput setaf 2)'ALL'$(tput sgr0) or $(tput setaf 2)'EN_ONLY'$(tput sgr0) are allowed as language '-l' argument!"
  663. exit 24
  664. fi
  665. fi
  666. #Check if DEV_STATUS is selected via argument '-d'
  667. if [ ! -z "$devel_flag" ] ; then
  668. if [[ "$devel_flag" == "GOLD" || "$devel_flag" == "RC" || "$devel_flag" == "BETA" || "$devel_flag" == "ALPHA" || "$devel_flag" == "DEVEL" || "$devel_flag" == "DEBUG" || "$devel_flag" == "UNKNOWN" ]] ; then
  669. DEV_STATUS_SELECTED=$devel_flag
  670. elif [[ "$devel_flag" == "atmega404" || "$devel_flag" == "atmega404_no_bootloader" ]] ; then
  671. MK404_DEBUG=$devel_flag
  672. else
  673. echo "$(tput setaf 1)Development argument is wrong!$(tput sgr0)"
  674. echo "Only $(tput setaf 2)'GOLD', 'RC', 'BETA', 'ALPHA', 'DEVEL', 'DEBUG' or 'UNKNOWN' $(tput sgr0) are allowed as devel '-d' argument!$(tput sgr0)"
  675. exit 25
  676. fi
  677. fi
  678. #Check if Build is selected via argument '-b'
  679. if [ ! -z "$build_flag" ] ; then
  680. if [[ "$build_flag" == "Auto" && "$git_available" == "1" ]] ; then
  681. echo "Build changed to $build_flag"
  682. BUILD=$(git rev-list --count HEAD)
  683. elif [[ $build_flag =~ ^[0-9]+$ ]] ; then
  684. BUILD=$build_flag
  685. else
  686. echo "$(tput setaf 1)Build number argument is wrong!$(tput sgr0)"
  687. echo "Only $(tput setaf 2)'Auto' (git needed) or numbers $(tput sgr0) are allowed as build '-b' argument!$(tput sgr0)"
  688. exit 26
  689. fi
  690. echo "New Build number is: $BUILD"
  691. fi
  692. # check if script has been started with arguments
  693. if [[ "$#" -eq "0" || "$output_flag" == 1 ]] ; then
  694. OUTPUT=1
  695. else
  696. OUTPUT=0
  697. fi
  698. #echo "Output is:" $OUTPUT
  699. #Check git branch has changed
  700. if [ ! -z "git_available" ]; then
  701. BRANCH=""
  702. CLEAN_PF_FW_BUILD=0
  703. else
  704. BRANCH=$(git branch --show-current)
  705. echo "Current branch is:" $BRANCH
  706. if [ ! -f "$SCRIPT_PATH/../PF-build.branch" ]; then
  707. echo "$BRANCH" >| $SCRIPT_PATH/../PF-build.branch
  708. echo "created PF-build.branch file"
  709. else
  710. PRE_BRANCH=$(cat "$SCRIPT_PATH/../PF-build.branch")
  711. echo "Previous branch was:" $PRE_BRANCH
  712. if [ ! "$BRANCH" == "$PRE_BRANCH" ] ; then
  713. CLEAN_PF_FW_BUILD=1
  714. echo "$BRANCH" >| $SCRIPT_PATH/../PF-build.branch
  715. fi
  716. fi
  717. fi
  718. #Set BUILD_ENV_PATH
  719. cd ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 27
  720. BUILD_ENV_PATH="$( pwd -P )"
  721. cd ../..
  722. #Checkif BUILD_PATH exists and if not creates it
  723. if [ ! -d "Prusa-Firmware-build" ]; then
  724. mkdir Prusa-Firmware-build || exit 28
  725. fi
  726. #Set the BUILD_PATH for Arduino IDE
  727. cd Prusa-Firmware-build || exit 29
  728. BUILD_PATH="$( pwd -P )"
  729. #Check git branch has changed
  730. if [ "$CLEAN_PF_FW_BUILD" == "1" ]; then
  731. read -t 10 -p "Branch changed, cleaning Prusa-Firmware-build folder"
  732. rm -r *
  733. else
  734. echo "Nothing to clean up"
  735. fi
  736. for v in ${VARIANTS[*]}
  737. do
  738. VARIANT=$(basename "$v" ".h")
  739. MK404_PRINTER=$(grep --max-count=1 "\bPRINTER_TYPE\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3 | cut -d '_' -f2)
  740. # Find firmware version in Configuration.h file and use it to generate the hex filename
  741. FW_MAJOR=$(grep --max-count=1 "\bFW_MAJOR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  742. FW_MINOR=$(grep --max-count=1 "\bFW_MINOR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  743. FW_REVISION=$(grep --max-count=1 "\bFW_REVISION\b" $SCRIPT_PATH/Firmware/Configuration.h| sed -e's/ */ /g'|cut -d ' ' -f3)
  744. FW="$FW_MAJOR$FW_MINOR$FW_REVISION"
  745. #FW=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g')
  746. if [ -z "$BUILD" ] ; then
  747. # Find build version in Configuration.h file and use it to generate the hex filename
  748. BUILD=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  749. else
  750. # Find and replace build version in Configuration.h file
  751. BUILD_ORG=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  752. echo "Original build number: $BUILD_ORG"
  753. sed -i -- "s/^#define FW_COMMIT_NR.*/#define FW_COMMIT_NR $BUILD/g" $SCRIPT_PATH/Firmware/Configuration.h
  754. fi
  755. # Check if the motherboard is an EINSY and if so only one hex file will generated
  756. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  757. # Check development status
  758. FW_FLAV=$(grep --max-count=1 "//#define FW_FLAVOR\b" $SCRIPT_PATH/Firmware/Configuration.h|cut -d ' ' -f1)
  759. if [[ "$FW_FLAV" != "//#define" ]] ; then
  760. FW_FLAVOR=$(grep --max-count=1 "\bFW_FLAVOR\b" $SCRIPT_PATH/Firmware/Configuration.h| sed -e's/ */ /g'|cut -d ' ' -f3)
  761. FW_FLAVERSION=$(grep --max-count=1 "\bFW_FLAVERSION\b" $SCRIPT_PATH/Firmware/Configuration.h| sed -e's/ */ /g'|cut -d ' ' -f3)
  762. if [[ "$FW_FLAVOR" != "//#define FW_FLAVOR" ]] ; then
  763. FW="$FW-$FW_FLAVOR"
  764. DEV_CHECK="$FW_FLAVOR"
  765. if [ ! -z "$FW_FLAVERSION" ] ; then
  766. FW="$FW$FW_FLAVERSION"
  767. fi
  768. fi
  769. fi
  770. DEV_CHECK=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g'|cut -d '-' -f2)
  771. if [ -z "$DEV_STATUS_SELECTED" ] ; then
  772. if [[ "$DEV_CHECK" == *"RC"* ]] ; then
  773. DEV_STATUS="RC"
  774. elif [[ "$DEV_CHECK" == *"ALPHA"* ]]; then
  775. DEV_STATUS="ALPHA"
  776. elif [[ "$DEV_CHECK" == *"BETA"* ]]; then
  777. DEV_STATUS="BETA"
  778. elif [[ "$DEV_CHECK" == "DEVEL" ]]; then
  779. DEV_STATUS="DEVEL"
  780. elif [[ "$DEV_CHECK" == "DEBUG" ]]; then
  781. DEV_STATUS="DEBUG"
  782. else
  783. DEV_STATUS="UNKNOWN"
  784. echo
  785. echo "$(tput setaf 5)DEV_STATUS is UNKNOWN. Do you wish to set DEV_STATUS to GOLD?$(tput sgr0)"
  786. PS3="Select YES only if source code is tested and trusted: "
  787. select yn in "Yes" "No"; do
  788. case $yn in
  789. Yes)
  790. DEV_STATUS="GOLD"
  791. DEV_STATUS_SELECTED="GOLD"
  792. break
  793. ;;
  794. No)
  795. DEV_STATUS="UNKNOWN"
  796. DEV_STATUS_SELECTED="UNKNOWN"
  797. break
  798. ;;
  799. *)
  800. echo "$(tput setaf 1)This is not a valid DEV_STATUS$(tput sgr0)"
  801. ;;
  802. esac
  803. done
  804. fi
  805. else
  806. DEV_STATUS=$DEV_STATUS_SELECTED
  807. fi
  808. #Prepare hex files folders
  809. if [ ! -d "$SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD" ]; then
  810. mkdir -p $SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD || exit 28
  811. fi
  812. OUTPUT_FOLDER="PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD"
  813. if [ "$BOARD" != "prusa_einsy_rambo" ]; then
  814. if [ ! -d "$SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$BOARD" ]; then
  815. mkdir -p $SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$BOARD || exit 28
  816. fi
  817. OUTPUT_FOLDER="PF-build-hex/FW$FW-Build$BUILD/$BOARD"
  818. fi
  819. #Define OUTPUT_FILENAME
  820. OUTPUT_FILENAME=FW$FW-Build$BUILD-$VARIANT
  821. #Check for OUTPUT_FILENAME_SUFFIX and add it
  822. if [ ! -z $OUTPUT_FILENAME_SUFFIX ]; then
  823. OUTPUT_FILENAME="${OUTPUT_FILENAME}$OUTPUT_FILENAME_SUFFIX"
  824. fi
  825. #Check if exactly the same hexfile already exists
  826. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/$OUTPUT_FILENAME.hex" && "$LANGUAGES" == "ALL" ]]; then
  827. echo ""
  828. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/$OUTPUT_FILENAME.hex | xargs -n1 basename
  829. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  830. if [ $OUTPUT == "1" ] ; then
  831. read -t 10 -p "Press Enter to continue..."
  832. fi
  833. elif [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/$OUTPUT_FILENAME-EN_ONLY.hex" && "$LANGUAGES" == "EN_ONLY" ]]; then
  834. echo ""
  835. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/$OUTPUT_FILENAME-EN_ONLY.hex | xargs -n1 basename
  836. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  837. if [ $OUTPUT == "1" ] ; then
  838. read -t 10 -p "Press Enter to continue..."
  839. fi
  840. fi
  841. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/$OUTPUT_FILENAME.zip" && "$LANGUAGES" == "ALL" ]]; then
  842. echo ""
  843. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/$OUTPUT_FILENAME.zip | xargs -n1 basename
  844. echo "$(tput setaf 6)This zip file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  845. if [ $OUTPUT == "1" ] ; then
  846. read -t 10 -p "Press Enter to continue..."
  847. fi
  848. fi
  849. #List some useful data
  850. echo "$(tput setaf 2)$(tput setab 7) "
  851. echo "Printer :" $MK404_PRINTER
  852. echo "Variant :" $VARIANT
  853. echo "Firmware :" $FW
  854. echo "Build # :" $BUILD
  855. echo "Dev Check :" $DEV_CHECK
  856. echo "DEV Status :" $DEV_STATUS
  857. echo "Motherboard :" $MOTHERBOARD
  858. echo "Board flash :" $BOARD_FLASH
  859. echo "Board mem :" $BOARD_MEM
  860. echo "Languages :" $LANGUAGES
  861. echo "Hex-file Folder:" $OUTPUT_FOLDER
  862. echo "Hex filename :" $OUTPUT_FILENAME
  863. echo "$(tput sgr0)"
  864. #Prepare Firmware to be compiled by copying variant as Configuration_prusa.h
  865. if [ ! -f "$SCRIPT_PATH/Firmware/Configuration_prusa.h" ]; then
  866. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 31
  867. else
  868. echo "$(tput setaf 6)Configuration_prusa.h already exist it will be overwritten in 10 seconds by the chosen variant.$(tput sgr 0)"
  869. if [ $OUTPUT == "1" ] ; then
  870. read -t 10 -p "Press Enter to continue..."
  871. fi
  872. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 31
  873. fi
  874. #Prepare Configuration.h to use the correct FW_DEV_VERSION to prevent LCD messages when connecting with OctoPrint
  875. sed -i -- "s/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/g" $SCRIPT_PATH/Firmware/Configuration.h
  876. # set FW_REPOSITORY
  877. sed -i -- 's/#define FW_REPOSITORY "Unknown"/#define FW_REPOSITORY "Prusa3d"/g' $SCRIPT_PATH/Firmware/Configuration.h
  878. #Prepare English only or multi-language version to be build
  879. if [ $LANGUAGES == "EN_ONLY" ]; then
  880. echo " "
  881. echo "English only language firmware will be built"
  882. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE 0/g" $SCRIPT_PATH/Firmware/config.h
  883. echo " "
  884. else
  885. echo " "
  886. echo "Multi-language firmware will be built"
  887. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE 1/g" $SCRIPT_PATH/Firmware/config.h
  888. echo " "
  889. fi
  890. #Check if compiler flags are set to Prusa specific needs for the rambo board.
  891. #if [ $TARGET_OS == "windows" ]; then
  892. #RAMBO_PLATFORM_FILE="PrusaResearchRambo/avr/platform.txt"
  893. #fi
  894. #New fresh PF-Firmware-build
  895. if [ "$new_build_flag" == "1" ]; then
  896. rm -r -f $BUILD_PATH/* || exit 54
  897. fi
  898. # Prepare Board mem and flash modifications
  899. ## Check board mem size
  900. CURRENT_BOARD_MEM=$(grep "#define RAMEND" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h | sed -e's/.* //g'|cut -d ' ' -f3|tr -d $'\n')
  901. if [ $CURRENT_BOARD_MEM != "0x21FF" ] ; then
  902. echo "Board mem has been already modified or not reset"
  903. echo "Current:" $CURRENT_BOARD_MEM
  904. PS3="Select $(tput setaf 2)Yes$(tput sgr 0) if you want to reset it."
  905. select yn in "Yes" "No"; do
  906. case $yn in
  907. Yes)
  908. echo "Resetting board mem size"
  909. sed -i -- "s/^#define RAMEND .*$/#define RAMEND 0x21FF/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  910. break
  911. ;;
  912. *)
  913. echo "Continuing with modified mem size"
  914. break
  915. ;;
  916. esac
  917. done
  918. fi
  919. ## Modify board mem size
  920. if [[ ! -z $BOARD_MEM && "$BOARD_MEM" != "0x21FF" ]] ; then
  921. echo "$(tput setaf 3)Modifying board memory size (hex):$(tput sgr 0)"
  922. echo "Old:" $CURRENT_BOARD_MEM
  923. echo "New:" $BOARD_MEM
  924. read -t 5 -p "To cancel press $(tput setaf 1)CRTL+C$(tput sgr 0)"
  925. echo ""
  926. sed -i -- "s/^#define RAMEND 0x21FF/#define RAMEND ${BOARD_MEM}/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  927. fi
  928. ## Check board flash size
  929. CURRENT_BOARD_FLASH=$(grep "#define FLASHEND" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h | sed -e's/.* //g'|cut -d ' ' -f3|tr -d $'\n')
  930. CURRENT_BOARD_maximum_size=$(grep "prusa_einsy_rambo.upload.maximum_size" $BUILD_ENV_PATH/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION/boards.txt |cut -d '=' -f2|tr -d $'\n')
  931. if [[ $CURRENT_BOARD_FLASH != "0x3FFFF" || $CURRENT_BOARD_maximum_size != "253952" ]] ; then
  932. echo "Board flash has been already modified or not reset"
  933. echo "Current flash size:" $CURRENT_BOARD_FLASH
  934. echo "Current max. size:" $CURRENT_BOARD_maximum_size
  935. PS3="Select $(tput setaf 2)Yes$(tput sgr 0) if you want to reset it."
  936. select yn in "Yes" "No"; do
  937. case $yn in
  938. Yes)
  939. echo "$(tput setaf 1)Resetting board flash size$(tput sgr 0)"
  940. sed -i -- "s/^#define FLASHEND .*$/#define FLASHEND 0x3FFFF/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  941. sed -i -- "s/^prusa_einsy_rambo.upload.maximum_size.*/prusa_einsy_rambo.upload.maximum_size=253952/g" $BUILD_ENV_PATH/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION/boards.txt
  942. break
  943. ;;
  944. *)
  945. echo "$(tput setaf 3)Continuing with modified flash size$(tput sgr 0)"
  946. break
  947. ;;
  948. esac
  949. done
  950. fi
  951. ## Modify boad flash size
  952. if [[ ! -z $BOARD_FLASH && "$BOARD_FLASH" != "0x3FFFF" ]] ; then
  953. echo "Modifying board flash size (hex):"
  954. echo "Old flash size:" $CURRENT_BOARD_FLASH
  955. echo "New flash size:" $BOARD_FLASH
  956. echo "Old max. size:" $CURRENT_BOARD_maximum_size
  957. echo "New max. size:" $BOARD_maximum_size
  958. read -t 5 -p "To cancel press $(tput setaf 1)CRTL+C$(tput sgr 0)"
  959. sed -i -- "s/^#define FLASHEND .*/#define FLASHEND ${BOARD_FLASH}/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  960. sed -i -- "s/^prusa_einsy_rambo.upload.maximum_size.*/prusa_einsy_rambo.upload.maximum_size=${BOARD_maximum_size}/g" $BUILD_ENV_PATH/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION/boards.txt
  961. fi
  962. #Check if compiler flags are set to Prusa specific needs for the rambo board.
  963. # if [ $TARGET_OS == "windows" ]; then
  964. # RAMBO_PLATFORM_FILE="PrusaResearchRambo/avr/platform.txt"
  965. # fi
  966. #### End of Prepare building
  967. #### Start building
  968. export ARDUINO=$BUILD_ENV_PATH
  969. #echo $BUILD_ENV_PATH
  970. #export BUILDER=$ARDUINO/arduino-builder
  971. echo
  972. #read -t 5 -p "Press Enter..."
  973. echo
  974. echo "Start to build Prusa Firmware ..."
  975. echo "Using variant $VARIANT$(tput setaf 3)"
  976. if [ $OUTPUT == "1" ] ; then
  977. sleep 2
  978. fi
  979. if [ $verbose_IDE == "1" ]; then
  980. $BUILD_ENV_PATH/arduino-builder -dump-prefs -debug-level 10 -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 41
  981. fi
  982. $BUILD_ENV_PATH/arduino-builder -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all -verbose=$verbose_IDE $SCRIPT_PATH/Firmware/Firmware.ino || exit 42
  983. echo "$(tput sgr 0)"
  984. if [ $LANGUAGES == "ALL" ]; then
  985. echo "$(tput setaf 2)"
  986. echo "Building multi language firmware" $MULTI_LANGUAGE_CHECK
  987. echo "$(tput sgr 0)"
  988. if [ $OUTPUT == "1" ] ; then
  989. sleep 2
  990. fi
  991. cd $SCRIPT_PATH/lang
  992. echo "$(tput setaf 3)"
  993. ./config.sh || exit 43
  994. echo "$(tput sgr 0)"
  995. # Check if previous languages and firmware build exist and if so clean them up
  996. if [ -f "lang_en.tmp" ]; then
  997. echo ""
  998. echo "$(tput setaf 6)Previous lang build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  999. if [ $OUTPUT == "1" ] ; then
  1000. read -t 10 -p "Press Enter to continue..."
  1001. fi
  1002. echo "$(tput setaf 3)"
  1003. ./lang-clean.sh
  1004. echo "$(tput sgr 0)"
  1005. fi
  1006. if [ -f "progmem.out" ]; then
  1007. echo ""
  1008. echo "$(tput setaf 6)Previous firmware build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  1009. if [ $OUTPUT == "1" ] ; then
  1010. read -t 10 -p "Press Enter to continue..."
  1011. fi
  1012. echo "$(tput setaf 3)"
  1013. ./fw-clean.sh
  1014. echo "$(tput sgr 0)"
  1015. fi
  1016. # build languages
  1017. echo "$(tput setaf 3)"
  1018. ./lang-build.sh || exit 44
  1019. # build community languages
  1020. ./lang-community.sh || exit 45
  1021. # Combine compiled firmware with languages
  1022. ./fw-build.sh || exit 46
  1023. cp not_tran.txt not_tran_$VARIANT.txt
  1024. cp not_used.txt not_used_$VARIANT.txt
  1025. echo "$(tput sgr 0)"
  1026. # Check if the motherboard is an EINSY and if so only one hex file will generated
  1027. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  1028. # If the motherboard is an EINSY just copy one hexfile
  1029. if [ "$MOTHERBOARD" = "BOARD_EINSY_1_0a" ]; then
  1030. echo "$(tput setaf 2)Copying multi language firmware for MK3/Einsy board to PF-build-hex folder$(tput sgr 0)"
  1031. # End of "lang.bin" for MK3 and MK3S copy
  1032. cp -f firmware.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/$OUTPUT_FILENAME.hex
  1033. cp -f $BUILD_PATH/Firmware.ino.elf $SCRIPT_PATH/../$OUTPUT_FOLDER/$OUTPUT_FILENAME.elf
  1034. else
  1035. echo "$(tput setaf 2)Zip multi language firmware for MK2.5/miniRAMbo board to PF-build-hex folder$(tput sgr 0)"
  1036. cp -f firmware_cz.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/$OUTPUT_FILENAME-cz.hex
  1037. cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/$OUTPUT_FILENAME-de.hex
  1038. cp -f firmware_es.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/$OUTPUT_FILENAME-es.hex
  1039. cp -f firmware_fr.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/$OUTPUT_FILENAME-fr.hex
  1040. cp -f firmware_it.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/$OUTPUT_FILENAME-it.hex
  1041. cp -f firmware_pl.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/$OUTPUT_FILENAME-pl.hex
  1042. cp -f firmware_nl.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/$OUTPUT_FILENAME-nl.hex
  1043. cp -f $BUILD_PATH/Firmware.ino.elf $SCRIPT_PATH/../$OUTPUT_FOLDER/$OUTPUT_FILENAME.elf
  1044. if [ $TARGET_OS == "windows" ]; then
  1045. zip a $SCRIPT_PATH/../$OUTPUT_FOLDER/$OUTPUT_FILENAME.zip $SCRIPT_PATH/../$OUTPUT_FOLDER/$OUTPUT_FILENAME-??.hex
  1046. rm $SCRIPT_PATH/../$OUTPUT_FOLDER/$OUTPUT_FILENAME-??.hex
  1047. elif [ $TARGET_OS == "linux" ]; then
  1048. # Make a copy for MK404 sim of MK2, MK2.5, MK2.5S firmware
  1049. if [ ! -z "$mk404_flag" ]; then
  1050. cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/$OUTPUT_FILENAME.hex
  1051. fi
  1052. # End of MK2, MK2.5, MK2.5S firmware copy
  1053. zip -m -j ../../$OUTPUT_FOLDER/$OUTPUT_FILENAME.zip ../../$OUTPUT_FOLDER/$OUTPUT_FILENAME-??.hex
  1054. fi
  1055. fi
  1056. # Cleanup after build
  1057. if [[ -z "$clean_flag" || "$clean_flag" == "0" ]]; then
  1058. echo "$(tput setaf 3)"
  1059. ./fw-clean.sh || exit 51
  1060. ./lang-clean.sh || exit 52
  1061. echo "$(tput sgr 0)"
  1062. fi
  1063. else
  1064. echo "$(tput setaf 2)Copying English only firmware to PF-build-hex folder$(tput sgr 0)"
  1065. cp -f $BUILD_PATH/Firmware.ino.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/$OUTPUT_FILENAME-EN_ONLY.hex || exit 47
  1066. echo "$(tput setaf 2)Copying English only elf file to PF-build-hex folder$(tput sgr 0)"
  1067. cp -f $BUILD_PATH/Firmware.ino.elf $SCRIPT_PATH/../$OUTPUT_FOLDER/$OUTPUT_FILENAME-EN_ONLY.elf || exit 47
  1068. fi
  1069. # Cleanup Firmware
  1070. if [[ -z "$prusa_flag" || "$prusa_flag" == "0" ]]; then
  1071. rm $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 53
  1072. fi
  1073. # Delete dupblicates
  1074. if find $SCRIPT_PATH/lang/ -name '*RAMBo10a*.txt' -printf 1 -quit | grep -q 1
  1075. then
  1076. rm $SCRIPT_PATH/lang/*RAMBo10a*.txt
  1077. fi
  1078. # MK2 not supported in this branch
  1079. if find $SCRIPT_PATH/lang/ -name '*MK2-RAMBo13a*' -printf 1 -quit | grep -q 1
  1080. then
  1081. rm $SCRIPT_PATH/lang/*MK2-RAMBo13a*.txt
  1082. fi
  1083. if find $SCRIPT_PATH/lang/ -name 'not_tran.txt' -printf 1 -quit | grep -q 1
  1084. then
  1085. rm $SCRIPT_PATH/lang/not_tran.txt
  1086. fi
  1087. if find $SCRIPT_PATH/lang/ -name 'not_used.txt' -printf 1 -quit | grep -q 1
  1088. then
  1089. rm $SCRIPT_PATH/lang/not_used.txt
  1090. fi
  1091. #New fresh PF-Firmware-build
  1092. if [ "$new_build_flag" == "1" ]; then
  1093. rm -r -f $BUILD_PATH/* || exit 54
  1094. fi
  1095. # Restore files to previous state
  1096. sed -i -- "s/^#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/g" $SCRIPT_PATH/Firmware/Configuration.h
  1097. sed -i -- 's/^#define FW_REPOSITORY "Prusa3d"/#define FW_REPOSITORY "Unknown"/g' $SCRIPT_PATH/Firmware/Configuration.h
  1098. if [ ! -z "$BUILD_ORG" ] ; then
  1099. sed -i -- "s/^#define FW_COMMIT_NR.*/#define FW_COMMIT_NR $BUILD_ORG/g" $SCRIPT_PATH/Firmware/Configuration.h
  1100. fi
  1101. echo $MULTI_LANGUAGE_CHECK
  1102. #sed -i -- "s/^#define LANG_MODE * /#define LANG_MODE $MULTI_LANGUAGE_CHECK/g" $SCRIPT_PATH/Firmware/config.h
  1103. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  1104. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  1105. if [ $OUTPUT == "1" ] ; then
  1106. sleep 5
  1107. fi
  1108. # Restore build env files to previous state
  1109. sed -i -- "s/^#define FLASHEND .*$/#define FLASHEND 0x3FFFF/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  1110. sed -i -- "s/^prusa_einsy_rambo.upload.maximum_size.*/prusa_einsy_rambo.upload.maximum_size=253952/g" $BUILD_ENV_PATH/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION/boards.txt
  1111. sed -i -- "s/^#define RAMEND.*/#define RAMEND 0x21FF/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  1112. done
  1113. # Switch to hex path and list build files
  1114. cd $SCRIPT_PATH
  1115. echo "$(tput setaf 2) "
  1116. echo " "
  1117. echo "Build done, please use Slic3rPE > 1.41.0 to upload the firmware"
  1118. echo "more information how to flash firmware https://www.prusa3d.com/drivers/ $(tput sgr 0)"
  1119. #### End building
  1120. #### MK404 Simulator
  1121. # Check/compile MK404 sim
  1122. if [ ! -z "$mk404_flag" ]; then
  1123. # For Prusa MK2, MK2.5/S
  1124. if [ "$MOTHERBOARD" == "BOARD_RAMBO_MINI_1_3" ]; then
  1125. MK404_PRINTER="${MK404_PRINTER}_mR13"
  1126. else
  1127. if [[ "$mk404_flag" == "2" || "$mk404_flag" == "MMU2" || "$mk404_flag" == "MMU2S" ]]; then # Check if MMU2 is selected only for MK3/S
  1128. MK404_PRINTER="${MK404_PRINTER}MMU2"
  1129. fi
  1130. fi
  1131. # Run MK404 with 'debugcore' and/or 'bootloader-file'
  1132. if [ ! -z "$board_mem_flag" ]; then
  1133. MK404_options="-x $board_mem_flag"
  1134. fi
  1135. if [ ! -z "$board_flash_flag" ]; then
  1136. MK404_options="${MK404_options} -y $board_flash_flag"
  1137. fi
  1138. # Run MK404 with graphics
  1139. if [ ! -z "$graphics_flag" ]; then
  1140. if [[ "$graphics_flag" == "1" || "$graphics_flag" == "2" || "$graphics_flag" == "3" || "$graphics_flag" == "4" ]]; then
  1141. MK404_options="${MK404_options} -g $graphics_flag"
  1142. else
  1143. echo "$(tput setaf 1)Unsupported MK404 graphics option $graphics_flag$(tput sgr 0)"
  1144. fi
  1145. fi
  1146. # Output some useful data
  1147. echo "Printer: $MK404_PRINTER"
  1148. echo "Options: $MK404_options"
  1149. echo ""
  1150. read -t 5 -p "Press $(tput setaf 2)Enter$(tput sgr 0) to start MK404"
  1151. echo ""
  1152. # Change to MK404 build folder
  1153. #cd ../MK404/master/build
  1154. #Decide which hex file to use EN_ONLY or Multi language
  1155. if [ "$LANGUAGES" == "ALL" ]; then
  1156. MK404_firmware_file=$SCRIPT_PATH/../$OUTPUT_FOLDER/$OUTPUT_FILENAME.hex
  1157. else
  1158. MK404_firmware_file=$SCRIPT_PATH/../$OUTPUT_FOLDER/$OUTPUT_FILENAME-EN_ONLY.hex
  1159. fi
  1160. # Start MK404
  1161. # default with serial output and terminal to manipulate it via terminal
  1162. #echo ""
  1163. #echo "./MK404 Prusa_$MK404_PRINTER -s --terminal $MK404_options -f $MK404_firmware_file"
  1164. #sleep 5
  1165. #./MK404 Prusa_$MK404_PRINTER -s --terminal $MK404_options -f $MK404_firmware_file || exit 62
  1166. echo ""
  1167. echo "./MK404-build.sh -m $mk404_flag -p $MK404_PRINTER $MK404_options -f $MK404_firmware_file"
  1168. sleep 5
  1169. ./MK404-build.sh -m $mk404_flag -p $MK404_PRINTER $MK404_options -f $MK404_firmware_file|| exit 61
  1170. fi
  1171. #### End of MK404 Simulator